#ifndef PCI_H
#define PCI_H

#include <arch/stdint.h>

#define PCI_VENDOR_ID 0
#define PCI_DEVICE_ID 2
#define PCI_CLASS_PROG 0x09
#define PCI_CLASS_DEVICE 0x0a
#define PCI_HEADER_TYPE 0x0e
#define  PCI_HEADER_TYPE_NORMAL 0
#define  PCI_HEADER_TYPE_BRIDGE 1
#define  PCI_HEADER_TYPE_CARDBUS 2
#define PCI_SECONDARY_BUS 0x19
#define PCI_BASE_ADDR_0 0x10
#define PCI_BASE_ADDR_1 0x14
#define PCI_BASE_ADDR_2 0x18
#define PCI_BASE_ADDR_3 0x1c
#define PCI_BASE_ADDR_4 0x20
#define PCI_BASE_ADDR_5 0x24

typedef uint32_t pci_addr;

#include <arch/pci.h>

struct pci_dev {
    pci_addr addr;
    uint16_t vendor, device;
    uint16_t devclass;
    uint8_t prog_if;
};

void pci_init(void);
struct pci_dev *pci_find_device(int vendor, int device, int devclass, int prog_if, int index);

#endif /* PCI_H */
