/*
 * Simple terminal for VMware serial port
 */
#include <stdio.h>
#include <curses.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

int main()
{
    int s;
    struct sockaddr_un addr;
    char buf[1024];
    int n;

    s = socket(PF_UNIX, SOCK_STREAM, 0);
    if (s < 0) {
	perror("socket");
	return 1;
    }

    memset(&addr, 0, sizeof addr);
    addr.sun_family = AF_UNIX;
    strcpy(addr.sun_path, "/tmp/vmserial");

    if (connect(s, (void *) &addr, sizeof addr) < 0) {
	perror("connect");
	return 1;
    }

    initscr();
    cbreak();
    if (fork()) {
	while ((n = read(s, buf, sizeof buf)) > 0)
	    write(1, buf, n);
	if (n < 0)
	    perror("read from socket");
    } else {
	while ((n = read(0, buf, sizeof buf)) > 0)
	    write(s, buf, n);
    }
    endwin();

    return 0;
}
